const _G = globalThis;
    _G._N            = Number;
        _G._MAX_SAFE_I$N = _N.MAX_SAFE_INTEGER;
        _G._MIN_SAFE_I$N = _N.MIN_SAFE_INTEGER;
    _G._BI           = BigInt;
        _G._MAX_SAFE_I$BI = _BI(_MAX_SAFE_I$N);
        _G._MIN_SAFE_I$BI = _BI(_MIN_SAFE_I$N);
         

const _gele         = (n,d,u)=>(n>=d)&&(n<=u);
const _gtle         = (n,d,u)=>(n> d)&&(n<=u);
const _gelt         = (n,d,u)=>(n>=d)&&(n< u);
const _gtlt         = (n,d,u)=>(n> d)&&(n< u);

const _is_safe_int   = (n)   => _gele( n, _MIN_SAFE_I$N,  _MAX_SAFE_I$N );
const _is_safe_bi    = (bi)  => _gele(bi, _MIN_SAFE_I$BI, _MAX_SAFE_I$BI);


const _bi                = (n)  =>  _BI(n);
const _num2bi_if_necess  = (n)  =>  _is_safe_int(n)?n:_BI(n);
const _n                 = (bi) =>  _N(bi);
const _bi2num_if_noloss  = (bi) => !_is_safe_bi(bi)?bi:_N(bi);



module.exports = {
    _gele,_gtle,_gelt,_gtlt,
    _is_safe_int,_is_safe_bi,
    _bi,_n,
    _num2bi_if_necess,_bi2num_if_noloss,
}
